package RPM::Source::Transformation::Factory;

use strict;
use warnings;

use RPM::Source::Transformation::Component;
use RPM::Source::Transformation::OptHandlerWrapper;

our $VERSION=0.010;
our @ISA=qw(RPM::Source::Transformation::Component);

use Exporter 'import';
our @EXPORT = qw(TRANSFORMATION_FAILURE TRANSFORMATION_OK
PRIORITY_AT_BEGIN
PRIORITY_PRE_BUNDLE
PRIORITY_BUNDLE_SOURCE
PRIORITY_BUNDLE_PRECOLLECT
PRIORITY_BUNDLE_MAIN
PRIORITY_BUNDLE_COLLECT
PRIORITY_BUNDLE_POSTCOLLECT
PRIORITY_BUNDLE_VERIFY_METADATA
PRIORITY_BUNDLE_SETUP
PRIORITY_BUNDLE_RESET
PRIORITY_BUNDLE_PREFILL
PRIORITY_BUNDLE_FILL
PRIORITY_BUNDLE_POSTFILL
PRIORITY_POST_BUNDLE
PRIORITY_POST_BEGIN
PRIORITY_SRPM_AT_BEGIN
PRIORITY_SRPM_POST_BEGIN
PRIORITY_PREHOOKS
PRIORITY_PRECONVERT
PRIORITY_CONVERT
PRIORITY_FILTER_PREDISTROMAP
PRIORITY_FILTER_DISTROMAP
PRIORITY_FILTER_POSTDISTROMAP
PRIORITY_POSTCONVERT
PRIORITY_HOOKS
PRIORITY_POSTHOOKS
PRIORITY_COMMANDLINE
PRIORITY_DEFAULT
PRIORITY_POSTPROCESS
PRIORITY_PRERELEASE
PRIORITY_AT_END
);

use constant {
	TRANSFORMATION_FAILURE	=> RPM::Source::TransformContainer::TRANSFORMATION_FAILURE,
	TRANSFORMATION_OK	=> RPM::Source::TransformContainer::TRANSFORMATION_OK,

	PRIORITY_AT_BEGIN	=> 260,
	# bundle import...
	PRIORITY_PRE_BUNDLE	=> 250, # before main
	PRIORITY_BUNDLE_SOURCE	=> 240, # process input and setup SOURCES file(s)
	# TODO: deprecate me with PRIORITY_BUNDLE_COLLECT
	PRIORITY_BUNDLE_MAIN	=> 230, # main, like PerlBuilder.pm main
	PRIORITY_BUNDLE_PRECOLLECT	=> 220, # collecting parent quirks used (pkg_macros ...)
	PRIORITY_BUNDLE_COLLECT	=> 210, # collect in main, like in PerlBuilder.pm
	PRIORITY_BUNDLE_POSTCOLLECT	=> 200, # after main, still collecting metadata
	PRIORITY_BUNDLE_VERIFY_METADATA	=> 190, # after collecting metadata
	PRIORITY_BUNDLE_SETUP	=> 180, # apply metadata to spec
	PRIORITY_BUNDLE_RESET	=> 170, # reset; sync our macros with spec
	PRIORITY_BUNDLE_PREFILL	=> 160, # clean up parent quirks if any ...
	PRIORITY_BUNDLE_FILL	=> 150, # fill %prep,%build,%install,%files in main
	PRIORITY_BUNDLE_POSTFILL=> 140, # fill %prep,%build,%install,%files in plugins
	PRIORITY_POST_BUNDLE	=> 130,
	# srpmtool...
	PRIORITY_SRPM_AT_BEGIN	=> 120,
	PRIORITY_SRPM_POST_BEGIN=> 110,
	# will be removed/moved
	#PRIORITY_AT_BEGIN	=> 120,
	# keep til repocop release > 0.80
	PRIORITY_POST_BEGIN	=> 110,
	PRIORITY_PREHOOKS	=> 100,
	PRIORITY_PRECONVERT	=>  90,
	PRIORITY_CONVERT	=>  80,
	PRIORITY_FILTER_PREDISTROMAP	=>  70,
	PRIORITY_FILTER_DISTROMAP	=>  60,
	PRIORITY_FILTER_POSTDISTROMAP	=>  50,
	PRIORITY_POSTCONVERT	=>  40,
	PRIORITY_HOOKS		=>  30,
	PRIORITY_POSTHOOKS	=>  20,
	PRIORITY_COMMANDLINE	=>  10,
	PRIORITY_DEFAULT	=>  0,
	PRIORITY_POSTPROCESS	=> -10,
	PRIORITY_PRERELEASE	=> -20,
	PRIORITY_AT_END		=> -30,
};

sub init_factory {}
sub transformations {
    return;
}

1;
